#
# spec file for package firefox3-gtk2 (Version 2.10.6)
#
# Copyright (c) 2009 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild


Name:           firefox3-gtk2
BuildRequires:  cups-devel firefox3-atk-devel firefox3-cairo-devel firefox3-pango-devel gcc-c++ gnome-patch-translation gtkdoc libtiff-devel openssl-devel
Url:            http://www.gtk.org/
%define prefix /usr/%_lib/firefox
%define sysconfdir %{prefix}/etc
License:        LGPL v2.1 or later
Group:          System/Libraries
Provides:       gtk2+ 
AutoReqProv:    off
Requires:       gnome-filesystem
PreReq:         /usr/bin/touch /bin/rm /bin/rmdir
Version:        2.10.6
Release:        0.8.27
Summary:        Library for Creation of Graphical User Interfaces (version 2)
Source:         ftp://ftp.gnome.org/pub/GNOME/sources/gtk+/2.8/gtk+-%{version}.tar.bz2
Source1:        SuSEconfig.gtk2
Source2:        README.SuSE
Source3:        gtkrc
Patch:          gtk+-strict-aliasing.patch
Patch1:         gtk2-uninitialized.patch
Patch4:         gtk2-filesel-navbuttons.patch
Patch6:         gtk+-mac_ctree.patch
Patch8:         gtk64.patch
Patch12:        gdk-modules-information.diff
Patch14:        gtktextview.c.diff
Patch15:        gtk2-gtkicontheme-autoupdate.patch
Patch17:        gtk2-remove-empty-cache.patch
Patch22:        bugzilla-129753-gtk+-2.8.9-localize-font-style-name.diff
Patch23:        bugzilla-131498-allow-xim-for-all-languages.patch
Patch24:        gtk+-2.8.6-fontsel.patch
Patch31:        gtk+-2.8.6-fontsel-fix.patch
Patch32:        gtk2-set-invisible-char-to-circle.patch
Patch38:        gtk2-po.patch
Patch39:        gtk2-makefile-typo.patch
Patch40:        gdk-pixbuf-226710.patch
Patch41:        gtk2-235661-pixbuf-loader-error-checking.diff
Patch42:        gtk2-cups-backend.patch
Patch50:        gtk2-ignore-broken-modules.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
Requires:       firefox3-cairo >= 0.9.2 firefox3-pango firefox3-atk

%description
This fast and versatile library is used all over the world for all
libgnome (GNOME) applications, gimp (The GIMP), and several others.
Originally, version 1 was written for the GIMP and hence has the name
GIMP ToolKit. Many people like it because it is small, efficient, and
very configurable.

Most applications which used gtk (GTK1) have since switched to GTK2.
Besides a more flexible API, it provides improved text rendering using
pango (Pango) and many other goodies, but GTK+ 2 lacks compatibility
with GTK1, so to switch, programmers have to port applications to it.

To develop applications with gtk, you need the package gtk2-devel.

This package is provided for Firefox back-port on SLE10.



Authors:
--------
    Peter Mattis <petm@xcf.berkeley.edu>
    Spencer Kimball <spencer@xcf.berkeley.edu>
    Josh MacDonald <jmacd@xcf.berkeley.edu>
    Shawn T. Amundson <amundson@gtk.org>
    Jerome Bolliet <bolliet@gtk.org>
    Damon Chaplin <damon@gtk.org>
    Tony Gale <gale@gtk.org>
    Jeff Garzik <jgarzik@gtk.org>
    Lars Hamann <lars@gtk.org>
    Raja R Harinath <harinath@gtk.org>
    Carsten Haitzler <raster@gtk.org>
    Tim Janik <timj@gtk.org>
    Stefan Jeske <stefan@gtk.org>
    Elliot Lee <sopwith@gtk.org>
    Raph Levien <raph@gtk.org>
    Ian Main <imain@gtk.org>
    Federico Mena <quartic@gtk.org>
    Paolo Molaro <lupus@gtk.org>
    Jay Painter <jpaint@gtk.org>
    Manish Singh <manish@gtk.org>
    Owen Taylor <otaylor@gtk.org>

%package devel
License:        LGPL v2.1 or later
Summary:        Development environment for the Gtk2 GUI library
Group:          Development/Libraries/X11
AutoReqProv:    off
Requires:       %{name} = %{version}
Requires:       glibc-devel firefox3-glib2-devel firefox3-pango-devel firefox3-atk-devel %(rpm -q --whatprovides XFree86-devel --queryformat '%{NAME}')
Requires:       firefox3-cairo-devel

%description devel
This package contains all necessary include files, libraries,
configuration files and development tools needed to compile and link
applications using the gtk2 library.

In addition, it contains a large set of demo applications in source
code and manual pages for the provided Gtk2 development tools.

Gtk2 is a fast and versatile library is used all over the world for all
GNOME applications, the GIMP, and several other applications.
Originally it was written for the GIMP and hence has the name Gimp
ToolKit. Many people like it because it is small, efficient, and very
configurable.

This package is provided for Firefox back-port on SLE10.



Authors:
--------
    Peter Mattis <petm@xcf.berkeley.edu>
    Spencer Kimball <spencer@xcf.berkeley.edu>
    Josh MacDonald <jmacd@xcf.berkeley.edu>
    Shawn T. Amundson <amundson@gtk.org>
    Jerome Bolliet <bolliet@gtk.org>
    Damon Chaplin <damon@gtk.org>
    Tony Gale <gale@gtk.org>
    Jeff Garzik <jgarzik@gtk.org>
    Lars Hamann <lars@gtk.org>
    Raja R Harinath <harinath@gtk.org>
    Carsten Haitzler <raster@gtk.org>
    Tim Janik <timj@gtk.org>
    Stefan Jeske <stefan@gtk.org>
    Elliot Lee <sopwith@gtk.org>
    Raph Levien <raph@gtk.org>
    Ian Main <imain@gtk.org>
    Federico Mena <quartic@gtk.org>
    Paolo Molaro <lupus@gtk.org>
    Jay Painter <jpaint@gtk.org>
    Manish Singh <manish@gtk.org>
    Owen Taylor <otaylor@gtk.org>

%package doc
License:        LGPL v2.1 or later
Summary:        Additional Package Documentation for gtk2
Group:          Development/Libraries/X11
Requires:       %{name} = %{version}

%description doc
This fast and versatile library is used all over the world for all
GNOME applications, the GIMP, and several other applications.
Originally it was written for the GIMP and hence has the name Gimp
ToolKit. Many people like it because it is small, efficient, and very
configurable.

This package contains additional documentation.

This package is provided for Firefox back-port on SLE10.



Authors:
--------
    Peter Mattis <petm@xcf.berkeley.edu>
    Spencer Kimball <spencer@xcf.berkeley.edu>
    Josh MacDonald <jmacd@xcf.berkeley.edu>
    Shawn T. Amundson <amundson@gtk.org>
    Jerome Bolliet <bolliet@gtk.org>
    Damon Chaplin <damon@gtk.org>
    Tony Gale <gale@gtk.org>
    Jeff Garzik <jgarzik@gtk.org>
    Lars Hamann <lars@gtk.org>
    Raja R Harinath <harinath@gtk.org>
    Carsten Haitzler <raster@gtk.org>
    Tim Janik <timj@gtk.org>
    Stefan Jeske <stefan@gtk.org>
    Elliot Lee <sopwith@gtk.org>
    Raph Levien <raph@gtk.org>
    Ian Main <imain@gtk.org>
    Federico Mena <quartic@gtk.org>
    Paolo Molaro <lupus@gtk.org>
    Jay Painter <jpaint@gtk.org>
    Manish Singh <manish@gtk.org>
    Owen Taylor <otaylor@gtk.org>

%prep
%setup -q -n gtk+-%{version} 
gnome-patch-translation-prepare
%patch -p1
%patch1
%patch4 -p1
%patch6 -p1
cp -a %{S:1} .
%if "%_lib" == "lib64"
cp -a %{S:2} .
# WARNING: This patch does not patch not installed demos and tests.
%patch8 -p1
%endif
%patch12 -p1
%patch14 -p0
%patch15 -p0
%patch17 -p0
%patch22 -p1
%patch23 -p1
%patch24
%patch31
%patch32 -p1
%patch38 -p1
#%patch39
%patch40 -p1
%patch41 -p0
%patch42
%patch50 -p1
gnome-patch-translation-update

%build
export LD_LIBRARY_PATH=%{prefix}/%_lib:$LD_LIBRARY_PATH
export PKG_CONFIG_PATH=%{prefix}/%_lib/pkgconfig:$PKG_CONFIG_PATH
export PATH=%{prefix}/bin:$PATH
%{?suse_update_config:%{suse_update_config -f}}
libtoolize --force
aclocal -I m4macros
automake
autoconf 
## HACK ALERT BEGIN
# work around 9.2 deficiency
if test -f /usr/X11R6/%_lib/libXfixes.a -a ! -f /usr/X11R6/%_lib/libXfixes.so ; then
    ln -sf /usr/X11R6/%_lib/libXfixes.so.? gdk/libXfixes.so
    export LDFLAGS="-L."
fi
## HACK ALERT END
export CFLAGS="$RPM_OPT_FLAGS -fno-strict-aliasing"
%if %suse_version > 1000
export CFLAGS="$CFLAGS -fstack-protector"
%endif
%ifarch ppc64
export CFLAGS="$CFLAGS -mminimal-toc"
%endif
# Do not believe glibc first weekday:
# https://bugzilla.novell.com/show_bug.cgi?id=130787
# https://bugzilla.novell.com/show_bug.cgi?id=104417
# http://sources.redhat.com/bugzilla/show_bug.cgi?id=2388
sed -i /HAVE__NL_TIME_FIRST_WEEKDAY/d config.h.in
./configure --prefix=%{prefix} \
	    --libdir=%{prefix}/%_lib \
	    --with-native-locale=yes \
	    --with-xinput=xfree \
	    --mandir=%{prefix}/share/man \
	    --infodir=%{prefix}/share/info \
	    --sysconfdir=%{sysconfdir} \
	    --enable-shm \
	    --enable-xim \
	    --enable-fbmanager \
	    --with-gdktarget=x11 \
            --disable-gtk-doc
make %{?jobs:-j%jobs}

%install
rm -rf $RPM_BUILD_ROOT
export LIBRARY_PATH=$RPM_BUILD_ROOT/usr/%_lib:$RPM_BUILD_ROOT/usr/%_lib/gtk-2.0/%{version}/loaders:$RPM_BUILD_ROOT/usr/%_lib/gtk-2.0/%{version}
make install DESTDIR=$RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/sbin/conf.d
mkdir -p $RPM_BUILD_ROOT%{sysconfdir}/gtk-2.0
install -m 755 SuSEconfig.gtk2 $RPM_BUILD_ROOT/sbin/conf.d
touch $RPM_BUILD_ROOT%{sysconfdir}/gtk-2.0/gtk.immodules $RPM_BUILD_ROOT%{sysconfdir}/gtk-2.0/gdk-pixbuf.loaders
install %{SOURCE3} $RPM_BUILD_ROOT%{sysconfdir}/gtk-2.0
#mkdir -p $RPM_BUILD_ROOT/var%{prefix}/cache/gtk-2.0
#touch $RPM_BUILD_ROOT/var%{prefix}/cache/gtk-2.0/icon-theme.cache-list
mkdir -p $RPM_BUILD_ROOT%{prefix}/%_lib/gtk-2.0/{,2.10.0/}{engines,filesystems,immodules,loaders,modules,printbackends}
%find_lang gtk20
%find_lang gtk20-properties gtk20.lang
%if "%_lib" == "lib64"
mv $RPM_BUILD_ROOT%{prefix}/bin/gdk-pixbuf-query-loaders\
 $RPM_BUILD_ROOT%{prefix}/bin/gdk-pixbuf-query-loaders-64
mv $RPM_BUILD_ROOT%{prefix}/bin/gtk-query-immodules-2.0\
 $RPM_BUILD_ROOT%{prefix}/bin/gtk-query-immodules-2.0-64
mv $RPM_BUILD_ROOT%{sysconfdir}/gtk-2.0/gtk.immodules\
 $RPM_BUILD_ROOT%{sysconfdir}/gtk-2.0/gtk64.immodules
mv $RPM_BUILD_ROOT%{sysconfdir}/gtk-2.0/gdk-pixbuf.loaders\
 $RPM_BUILD_ROOT%{sysconfdir}/gtk-2.0/gdk-pixbuf64.loaders
%endif
gzip -9nf $RPM_BUILD_ROOT%{prefix}/share/man/man?/*.?
#mkdir -p $RPM_BUILD_ROOT/etc/profile.d
#echo 'if test -z "$GTK_PATH" ; then
#    export GTK_PATH="/usr/local/lib/gtk-2.0:/opt/gnome/lib/gtk-2.0:/usr/lib/gtk-2.0"
#else
#    export GTK_PATH="/usr/local/lib/gtk-2.0:/opt/gnome/lib/gtk-2.0:/usr/lib/gtk-2.0:$GTK_PATH"
#fi' > $RPM_BUILD_ROOT/etc/profile.d/%{name}.sh
#echo 'if ( ${?GTK_PATH} ) then
#    setenv GTK_PATH /usr/local/lib/gtk-2.0:/opt/gnome/lib/gtk-2.0:/usr/lib/gtk-2.0:${GTK_PATH}
#else
#    setenv GTK_PATH /usr/local/lib/gtk-2.0:/opt/gnome/lib/gtk-2.0:/usr/lib/gtk-2.0
#endif' > $RPM_BUILD_ROOT/etc/profile.d/%{name}.csh
#%if "%_lib" == "lib64"
#echo 'if test -z "$GTK_PATH64" ; then
#    export GTK_PATH64="/usr/local/%_lib/gtk-2.0:/opt/gnome/%_lib/gtk-2.0:/usr/%_lib/gtk-2.0"
#else
#    export GTK_PATH64="/usr/local/%_lib/gtk-2.0:/opt/gnome/%_lib/gtk-2.0:/usr/%_lib/gtk-2.0:$GTK_PATH64"
#fi' >> $RPM_BUILD_ROOT/etc/profile.d/%{name}.sh
#echo 'if ( ${?GTK_PATH64} ) then
#    setenv GTK_PATH64 /usr/local/%_lib/gtk-2.0:/opt/gnome/%_lib/gtk-2.0:/usr/%_lib/gtk-2.0:${GTK_PATH64}
#else
#    setenv GTK_PATH64 /usr/local/%_lib/gtk-2.0:/opt/gnome/%_lib/gtk-2.0:/usr/%_lib/gtk-2.0
#endif' >> $RPM_BUILD_ROOT/etc/profile.d/%{name}.csh
#%endif
chmod -x $RPM_BUILD_ROOT/%{sysconfdir}/gtk-2.0/gtkrc
rm $RPM_BUILD_ROOT%{prefix}/%_lib/gtk-2.0/2*/*/*.la

%clean
rm -rf $RPM_BUILD_ROOT

%pre
# Remove orphan files and directories obsolete since 9.0.
#rm -f\
# etc/gtk-2.0/gdk-pixbuf.loaders\
# etc/gtk-2.0/gtk.immodules
#rmdir\
# etc/gtk-2.0\
# usr/lib/gtk-2.0\
# 2>/dev/null || true

%post
%run_ldconfig
# FF3 backport should generate these files
%if "%_lib" == "lib64"
%{prefix}/bin/gdk-pixbuf-query-loaders-64 > \
 %{sysconfdir}/gtk-2.0/gdk-pixbuf64.loaders
%{prefix}/bin/gtk-query-immodules-2.0-64 > \
 %{sysconfdir}/gtk-2.0/gtk64.immodules
%else
%{prefix}/bin/gdk-pixbuf-query-loaders > \
 %{sysconfdir}/gtk-2.0/gdk-pixbuf.loaders
%{prefix}/bin/gtk-query-immodules-2.0 > \
 %{sysconfdir}/gtk-2.0/gtk.immodules
%endif
#touch var/adm/SuSEconfig/run-gtk

%preun
# Remove all old icon cache files created by SuSEconfig.gtk2.
# If it is an update, files will be re-created.
#if test -f var/opt/gnome/cache/gtk-2.0/icon-theme.cache-list ; then
#    for DIR in $(<var/opt/gnome/cache/gtk-2.0/icon-theme.cache-list) ; do
#	rm -f $DIR/icon-theme.cache
#	rmdir --ignore-fail-on-non-empty $DIR
#    done
#    rm var/opt/gnome/cache/gtk-2.0/icon-theme.cache-list
#fi

%postun
%run_ldconfig

%files -f %files -f gtk20.lang
%defattr(-,root,root)
%if "%_lib" == "lib64"
%doc AUTHORS COPYING README README.SuSE NEWS ChangeLog 
%ghost %{sysconfdir}/gtk-2.0/gtk64.immodules
%ghost %{sysconfdir}/gtk-2.0/gdk-pixbuf64.loaders
%else
%doc AUTHORS COPYING README NEWS ChangeLog 
%ghost %{sysconfdir}/gtk-2.0/gtk.immodules
%ghost %{sysconfdir}/gtk-2.0/gdk-pixbuf.loaders
%endif
%{sysconfdir}/gtk-2.0/gtkrc
%{prefix}/bin/*query*
%{prefix}/bin/gtk-update-icon-cache
%{prefix}/%_lib/lib*.so.*
%dir %{prefix}/%_lib/gtk-2.0/2.10.0
%dir %{prefix}/%_lib/gtk-2.0/2.10.0/engines
%dir %{prefix}/%_lib/gtk-2.0/2.10.0/filesystems
%dir %{prefix}/%_lib/gtk-2.0/2.10.0/immodules
%dir %{prefix}/%_lib/gtk-2.0/2.10.0/loaders
%dir %{prefix}/%_lib/gtk-2.0/2.10.0/modules
%dir %{prefix}/%_lib/gtk-2.0/2.10.0/printbackends
%{prefix}/%_lib/gtk-2.0/2.10.0/*/*.so
%dir %{prefix}/%_lib/gtk-2.0/engines
%dir %{prefix}/%_lib/gtk-2.0/filesystems
%dir %{prefix}/%_lib/gtk-2.0/immodules
%dir %{prefix}/%_lib/gtk-2.0/loaders
%dir %{prefix}/%_lib/gtk-2.0/modules
%dir %{prefix}/%_lib/gtk-2.0/printbackends
%dir %{prefix}/%_lib/gtk-2.0
%{prefix}/share/locale/
%exclude %{prefix}/share/themes/
%dir %{sysconfdir}/gtk-2.0
#/etc/profile.d/*
/sbin/conf.d/SuSEconfig.gtk2

%files devel
%defattr(-,root,root)
%{prefix}/bin/*-demo
%{prefix}/bin/*-csource
%{prefix}/include/gtk-2.0
%{prefix}/include/gtk-unix-print-2.0
%{prefix}/%_lib/lib*.so
%{prefix}/%_lib/lib*a
#%{prefix}/%_lib/gtk-2.0/2*/*/*.la
%{prefix}/%_lib/gtk-2.0/include
%{prefix}/%_lib/pkgconfig/*.pc
%{prefix}/share/gtk-2.0
%{prefix}/share/aclocal/*.m4
%doc %{prefix}/share/man/man*/*

%files doc
%defattr(-,root,root)
%dir %{prefix}/share/gtk-doc
%dir %{prefix}/share/gtk-doc/html
%{prefix}/share/gtk-doc/html/*

%changelog
* Fri Jul  3 2009 pwu@suse.de
- remove unneeded conditions in post/postun
- add post, postun in baselibs.conf
  Fixes bnc#518140.
* Wed Jul  1 2009 pwu@suse.de
- Add a environment varibles GTK210_BROKEN_MODULES to gtk 2.10,
  to avoid loading broken gtk 2.4 modules for Firefox 3.0 back port.
  Add a patch gtk2-ignore-broken-modules.patch. (Required by bnc#516713.)
* Tue Jun 23 2009 lrupp@suse.de
- disable autoreqprov in baselibs.conf
* Mon Jun 22 2009 kukuk@suse.de
- Add baselibs.conf
* Wed Jun  3 2009 pwu@suse.de
- Imported gtk2 2.10.6 from openSUSE 10.2,
  and rename it to firefox3-gtk2 to back port Firefox 3.0 for SLE10.
